A new version of mpfr is expected which isn't in Solaris yet, so we
are removing that functionality till we can get mpfr updated and
then will revert back these changes.

Not suitable for upstream

--- a/src/Makefile.am	Fri Jan 29 15:40:46 2016
+++ b/src/Makefile.am	Fri Jan 29 15:41:34 2016
@@ -33,8 +33,7 @@
 	--pkg gtk+-3.0 \
 	--pkg gtksourceview-3.0 \
 	--pkg libxml-2.0 \
-	$(top_builddir)/lib/libcalculator.vapi \
-	$(top_builddir)/lib/mpfr.vapi
+	$(top_builddir)/lib/libcalculator.vapi
 
 gnome_calculator_CPPFLAGS = \
 	$(AM_CPPFLAGS) \
@@ -54,8 +53,7 @@
 	--pkg gio-2.0 \
 	--pkg gtksourceview-3.0 \
 	--pkg libxml-2.0 \
-	$(top_builddir)/lib/libcalculator.vapi \
-	$(top_builddir)/lib/mpfr.vapi
+	$(top_builddir)/lib/libcalculator.vapi
 
 gcalccmd_LDADD = \
 	$(top_builddir)/lib/libcalculator.la
--- a/lib/Makefile.am	Fri Jan 29 15:42:13 2016
+++ b/lib/Makefile.am	Fri Jan 29 15:42:24 2016
@@ -10,7 +10,6 @@
 
 libcalculator_la_SOURCES = \
 	config.vapi \
-	mpfr.vapi \
 	currency.vala \
 	equation.vala \
 	equation-lexer.vala \
@@ -37,8 +36,7 @@
 libcalculator_la_LIBADD = \
 	$(LIBCALCULATOR_LIBS) \
 	-lgmp \
-	-lm \
-	-lmpfr
+	-lm
 
 EXTRA_DIST = \
 	libcalculator.h \
--- a/lib/equation-parser.vala	Fri Jan 29 15:47:35 2016
+++ b/lib/equation-parser.vala	Fri Jan 29 16:00:51 2016
@@ -78,20 +78,8 @@
         var r = right.solve ();
         if (r == null)
             return null;
-        var z = solve_r (r);
+        return solve_r (r);
 
-        /* check for errors */
-        Number.check_flags ();
-        if (Number.error != null)
-        {
-            var tmpleft = right;
-            var tmpright = right;
-            while (tmpleft.left != null) tmpleft = tmpleft.left;
-            while (tmpright.right != null) tmpright = tmpright.right;
-            parser.set_error (ErrorCode.MP, Number.error, tmpleft.token.start_index, tmpright.token.end_index);
-            Number.error = null;
-        }
-        return z;
     }
 
     public abstract Number solve_r (Number r);
@@ -110,20 +98,7 @@
         var r = right.solve ();
         if (l == null || r == null)
             return null;
-        var z = solve_lr (l, r);
-
-        /* check for errors */
-        Number.check_flags ();
-        if (Number.error != null)
-        {
-            var tmpleft = left;
-            var tmpright = right;
-            while (tmpleft.left != null) tmpleft = tmpleft.left;
-            while (tmpright.right != null) tmpright = tmpright.right;
-            parser.set_error (ErrorCode.MP, Number.error, tmpleft.token.start_index, tmpright.token.end_index);
-            Number.error = null;
-        }
-        return z;
+        return solve_lr (l, r);
     }
 
     public abstract Number solve_lr (Number left, Number r);
@@ -261,18 +236,6 @@
             value = value.multiply (t);
         }
 
-        /* check for errors */
-        Number.check_flags ();
-        if (Number.error != null)
-        {
-            var tmpleft = left;
-            var tmpright = right;
-            while (tmpleft.left != null) tmpleft = tmpleft.left;
-            while (tmpright.right != null) tmpright = tmpright.right;
-            parser.set_error (ErrorCode.MP, Number.error, tmpleft.token.start_index, tmpright.token.end_index);
-            Number.error = null;
-        }
-
         return value;
     }
 }
@@ -392,14 +355,6 @@
         if (tmp != null)
             tmp = tmp.xpowy_integer (pow);
 
-        /* check for errors */
-        Number.check_flags ();
-        if (Number.error != null)
-        {
-            parser.set_error (ErrorCode.MP, Number.error);
-            Number.error = null;
-        }
-
         return tmp;
     }
 }
@@ -574,17 +529,7 @@
 
     public override Number solve_lr (Number l, Number r)
     {
-        var z = l.divide (r);
-        if (Number.error != null)
-        {
-            var tmpleft = right;
-            var tmpright = right;
-            while (tmpleft.left != null) tmpleft = tmpleft.left;
-            while (tmpright.right != null) tmpright = tmpright.right;
-            parser.set_error (ErrorCode.MP, Number.error, tmpleft.token.start_index, tmpright.token.end_index);
-            Number.error = null;
-        }
-        return z;
+        return l.divide (r);
     }
 }
 
@@ -604,21 +549,8 @@
             var mod = right.solve ();
             if (base_value == null || exponent == null || mod == null)
                 return null;
-            var z = base_value.modular_exponentiation (exponent, mod);
+            return base_value.modular_exponentiation (exponent, mod);
 
-            /* check for errors */
-            Number.check_flags ();
-            if (Number.error != null)
-            {
-                var tmpleft = left;
-                var tmpright = right;
-                while (tmpleft.left != null) tmpleft = tmpleft.left;
-                while (tmpright.right != null) tmpright = tmpright.right;
-                parser.set_error (ErrorCode.MP, Number.error, tmpleft.token.start_index, tmpright.token.end_index);
-                Number.error = null;
-            }
-
-            return z;
         }
         else
         {
@@ -626,21 +558,8 @@
             var r = right.solve ();
             if (l == null || r == null)
                 return null;
-            var z = solve_lr (l, r);
+            return solve_lr (l, r);
 
-            /* check for errors */
-            Number.check_flags ();
-            if (Number.error != null)
-            {
-                var tmpleft = left;
-                var tmpright = right;
-                while (tmpleft.left != null) tmpleft = tmpleft.left;
-                while (tmpright.right != null) tmpright = tmpright.right;
-                parser.set_error (ErrorCode.MP, Number.error, tmpleft.token.start_index, tmpright.token.end_index);
-                Number.error = null;
-            }
-
-            return z;
         }
     }
 
@@ -709,21 +628,8 @@
         if (val == null)
             return null;
 
-        var z = val.xpowy_integer (pow);
+        return val.xpowy_integer (pow);
 
-        /* check for errors */
-        Number.check_flags ();
-        if (Number.error != null)
-        {
-            var tmpleft = left;
-            var tmpright = right;
-            while (tmpleft.left != null) tmpleft = tmpleft.left;
-            while (tmpright.right != null) tmpright = tmpright.right;
-            parser.set_error (ErrorCode.MP, Number.error, tmpleft.token.start_index, tmpright.token.end_index);
-            Number.error = null;
-        }
-
-        return z;
     }
 }
 
@@ -1036,10 +942,10 @@
         }
 
         representation_base = this.representation_base;
-        error_code = this.error;
-        error_token = this.error_token;
-        error_start = this.error_token_start;
-        error_end = this.error_token_end;
+        error_code = ErrorCode.NONE; 
+        error_token = null;
+        error_start = 0;
+        error_end = 0;
         return ans;
     }
 
--- a/lib/equation.vala	Fri Jan 29 16:01:11 2016
+++ b/lib/equation.vala	Fri Jan 29 16:02:09 2016
@@ -117,17 +117,15 @@
     public new Number? parse (out uint representation_base = null, out ErrorCode error_code = null, out string? error_token = null, out uint? error_start = null, out uint? error_end = null)
     {
         var parser = new EquationParser (this, expression);
-        Number.error = null;
+        mp_clear_error();
 
         var z = parser.parse (out representation_base, out error_code, out error_token, out error_start, out error_end);
 
         /* Error during parsing */
         if (error_code != ErrorCode.NONE)
-        {
             return null;
-        }
 
-        if (Number.error != null)
+        if (mp_get_error() != null)
         {
             error_code = ErrorCode.MP;
             return null;
--- a/src/gnome-calculator.vala	Fri Jan 29 16:05:17 2016
+++ b/src/gnome-calculator.vala	Fri Jan 29 16:06:27 2016
@@ -56,7 +56,6 @@
         var target_currency = settings.get_string ("target-currency");
         var source_units = settings.get_string ("source-units");
         var target_units = settings.get_string ("target-units");
-        var precision = settings.get_int ("precision");
 
         var equation = new MathEquation ();
         equation.accuracy = accuracy;
@@ -69,7 +68,6 @@
         equation.target_currency = target_currency;
         equation.source_units = source_units;
         equation.target_units = target_units;
-        Number.precision = precision;
 
         add_action_entries (app_entries, this);
 
@@ -173,7 +171,7 @@
             }
             else if (error == ErrorCode.MP)
             {
-                stderr.printf ("Error: %s\n", Number.error);
+                stderr.printf ("Error: %s\n", mp_get_error());
                 return Posix.EXIT_FAILURE;
             }
             else
--- a/src/gcalccmd.vala	Fri Jan 29 16:03:42 2016
+++ b/src/gcalccmd.vala	Fri Jan 29 16:04:56 2016
@@ -34,18 +34,9 @@
 
     result_serializer.set_representation_base (representation_base);
     if (z != null)
-    {
-        var str = result_serializer.to_string (z);
-        if (result_serializer.error != null)
-        {
-            stderr.printf ("%s\n", result_serializer.error);
-            result_serializer.error = null;
-        }
-        else
-            stdout.printf ("%s\n", str);
-    }
+	stdout.printf ("%s\n", result_serializer.to_string (z));
     else if (ret == ErrorCode.MP)
-        stderr.printf ("Error %s\n", Number.error);
+        stderr.printf ("Error %s\n", mp_get_error());
     else
         stderr.printf ("Error %d\n", ret);
 }
--- a/lib/math-equation.vala	Fri Jan 29 16:33:36 2016
+++ b/lib/math-equation.vala	Fri Jan 29 16:39:56 2016
@@ -786,11 +786,6 @@
         ans_end_mark = create_mark (null, end, true);
         apply_tag (ans_tag, start, end);
 
-        if (serializer.error != null)
-        {
-            status = serializer.error;
-            serializer.error = null;
-        }
     }
 
     public new void insert (string text)
@@ -964,13 +959,11 @@
                 break;
 
             case ErrorCode.MP:
-                if (Number.error != null) // LEGACY, should never be run
+		if (mp_get_error () != null)
+		    solvedata.error = mp_get_error ();
+		else if (error_token != null)
                 {
-                    solvedata.error = Number.error;
-                }
-                else if (error_token != null) // should always be run
-                {
-                    solvedata.error = _("%s").printf (error_token);
+                    solvedata.error = _("Malformed expression at token '%s'").printf(error_token);
                     solvedata.error_start = error_start;
                     solvedata.error_end = error_end;
                 }
@@ -1015,8 +1008,6 @@
 
             /* Fix thousand separator offsets in the start and end offsets of error token. */
             error_token_fix_thousands_separator ();
-            /* Fix missing Parenthesis before the start and after the end offsets of error token */
-            error_token_fix_parenthesis ();
 
             /* Notify the GUI about the change in error token locations. */
             notify_property ("error-token-end");
@@ -1087,70 +1078,6 @@
             end.forward_chars (length);
         }
     }
-
-    /* Fix the offsets to consider starting  and ending parenthesis */
-    private void error_token_fix_parenthesis ()
-    {
-        unichar c;
-        int count = 0;
-        int real_end = display.index_of_nth_char (error_token_end);
-        int real_start = display.index_of_nth_char (error_token_start);
-
-        /* checks if there are more opening/closing parenthesis than closing/opening parenthesis */
-        for (int i = real_start; display.get_next_char (ref i, out c) && i <= real_end;)
-        {
-            if (c.to_string () == "(") count++;
-            if (c.to_string () == ")") count--;
-        }
-
-        /* if there are more opening than closing parenthesis and there are closing parenthesis
-           after the end offset, include those in the offsets */
-        for (int i = real_end; display.get_next_char (ref i, out c) && count > 0;)
-        {
-            if (c.to_string () == ")")
-            {
-                state.error_token_end++;
-                count--;
-            }
-            else
-            {
-                break;
-            }
-        }
-
-        /* the same for closing parenthesis */
-        for (int i = real_start; display.get_prev_char (ref i, out c) && count < 0;)
-        {
-            if (c.to_string () == "(")
-            {
-                state.error_token_start--;
-                count++;
-            }
-            else
-            {
-                break;
-            }
-        }
-
-        real_end = display.index_of_nth_char (error_token_end);
-        real_start = display.index_of_nth_char (error_token_start);
-
-        unichar d;
-
-        /* if there are opening parenthesis directly before aswell as closing parenthesis directly after the offsets, include those aswell */
-        while (display.get_next_char (ref real_end, out d) && display.get_prev_char (ref real_start, out c))
-        {
-            if (c.to_string () == "(" && d.to_string () == ")")
-            {
-                state.error_token_start--;
-                state.error_token_end++;
-            }
-            else
-            {
-                break;
-            }
-        }
-    }
 
     private void* factorize_real ()
     {
--- a/src/math-preferences.vala	Fri Jan 29 16:40:37 2016
+++ b/src/math-preferences.vala	Fri Jan 29 16:43:30 2016
@@ -90,7 +90,7 @@
         var string = _("Show %d decimal _places");
         var tokens = string.split ("%d", 2);
 
-        var decimal_places_adjustment = new Gtk.Adjustment (0.0, 0.0, 100.0, 1.0, 1.0, 0.0);
+        var decimal_places_adjustment = new Gtk.Adjustment (0.0, 0.0, 9.0, 1.0, 1.0, 0.0);
         decimal_places_spin = new Gtk.SpinButton (decimal_places_adjustment, 0.0, 0);
 
         if (tokens.length > 0)
--- a/lib/serializer.vala	Mon Feb  1 10:45:23 2016
+++ b/lib/serializer.vala	Mon Feb  1 10:46:37 2016
@@ -32,9 +32,6 @@
     private unichar tsep;            /* Locale specific thousands separator. */
     private int tsep_count;          /* Number of digits between separator. */
 
-    /* is set when an error (for example precision error while converting) occurs */
-    public string? error { get; set; default = null; }
-
     public Serializer (DisplayFormat format, int number_base, int trailing_digits)
     {
         var radix_string = Posix.nl_langinfo (Posix.NLItem.RADIXCHAR);
@@ -322,17 +319,8 @@
 
             var d = t3.to_integer ();
 
-            if (d < 16 && d >= 0)
-            {
-                string.prepend_c (digits[d]);
-            }
-            else
-            {
-                string.prepend_c ('?');
-                error = _("Precision error");
-                string.assign ("0");
-                break;
-            }
+            string.prepend_c (d < 16 ? digits[d] : '?');
+
             n_digits++;
 
             temp = t;
--- a/tests/test-number.vala	Mon Feb  1 10:48:08 2016
+++ b/tests/test-number.vala	Mon Feb  1 10:49:35 2016
@@ -72,6 +72,22 @@
     pass ();
 }
 
+private void test_float ()
+{
+    for (var a = -10.0f; a <= 10.0f; a += 0.5f)
+    {
+        var z = new Number.float (a);
+        if (z.to_float () != a)
+        {
+            fail ("Number.float (%f).to_float () -> %f, expected %f".printf (a, z.to_float (), a));
+            return;
+        }
+    }
+
+    pass ();
+}
+
+
 private void test_double ()
 {
     for (var a = -10.0; a <= 10.0; a += 0.5)
@@ -1074,6 +1090,7 @@
     test_integer ();
     test_unsigned_integer ();
     test_fraction ();
+    test_float ();
     test_double ();
     test_complex ();
     test_polar ();
--- a/tests/test-equation.c	Mon Feb  1 12:22:33 2016
+++ b/tests/test-equation.c	Mon Feb  1 12:22:47 2016
@@ -95,7 +95,7 @@
 		const gchar* _tmp1_ = NULL;
 		const gchar* _tmp2_ = NULL;
 		gchar* _tmp3_ = NULL;
-		_tmp1_ = number_get_error ();
+		_tmp1_ = mp_get_error ();
 		_tmp2_ = _tmp1_;
 		_tmp3_ = g_strdup_printf ("ErrorCode.MP(\"%s\")", _tmp2_);
 		result = _tmp3_;

